<?php

/**
 * @var $app FluentSupport\Framework\Foundation\Application
 */

// init integrations
(new \FluentSupportPro\App\Services\Integrations\IntegrationInit())->init();
(new \FluentSupportPro\App\Hooks\Handlers\WorkflowHandler())->init();


add_action('fluent_support/before_delete_email_box', function ($box) {
    if ($box->box_type == 'email') {
        (new \FluentSupportPro\App\Services\Integrations\FluentEmailPiping\Api)->removeMailBox([
            'masked_email_id' => $box->mapped_email,
            'site_url'        => site_url(),
            'box_token'       => $box->getMeta('_webhook_token')
        ]);
    }
});

add_action('admin_init', function () {
    $licenseManager = new \FluentSupportPro\App\Services\PluginManager\LicenseManager();
    $licenseManager->initUpdater();

    $licenseMessage = $licenseManager->getLicenseMessages();

    if ($licenseMessage) {
        add_action('admin_notices', function () use ($licenseMessage) {
            $class = 'notice notice-error fc_message';
            $message = $licenseMessage['message'];
            printf('<div class="%1$s"><p>%2$s</p></div>', esc_attr($class), $message);
        });
    }
}, 0);

$app->addAction('fluent_support\tickets_filter_customer', function ($query, $filter) {
    return (new \FluentSupport\App\Models\Ticket())->filterTicketByUser($provider='customer', $query, $filter);
}, 10, 2);

$app->addAction('fluent_support\tickets_filter_agent', function ($query, $filter) {
    return (new \FluentSupport\App\Models\Ticket())->filterTicketByUser($provider='agent', $query, $filter);
}, 10, 2);

$app->addAction('fluent_support\tickets_filter_tickets', function ($query, $filter){
    return (new \FluentSupport\App\Models\Ticket())->doSearchForAdvancedFilter($query, $filter);
},10, 2);



